Package org.springframework.security.web.webauthn.api

# Class PublicKeyCredentialCreationOptions

java.lang.Object
org.springframework.security.web.webauthn.api.PublicKeyCredentialCreationOptions

public final class PublicKeyCredentialCreationOptions extends Object
Represents the PublicKeyCredentialCreationOptions which is an argument to creating a new credential.

Since:
  6.4

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`PublicKeyCredentialCreationOptions.PublicKeyCredentialCreationOptionsBuilder`
Used to build `PublicKeyCredentialCreationOptions`.

## Method Summary

Modifier and Type
Method
Description
`static PublicKeyCredentialCreationOptions.PublicKeyCredentialCreationOptionsBuilder`
`builder()`
Creates a new `PublicKeyCredentialCreationOptions`
`AttestationConveyancePreference`
`getAttestation()`
The attestation property is an OPTIONAL member used by the Relying Party to specify a preference regarding attestation conveyance.
`AuthenticatorSelectionCriteria`
`getAuthenticatorSelection()`
The authenticatorSelection property is an OPTIONAL member used by the Relying Party to list any existing credentials mapped to this user account (as identified by user.id).
`Bytes`
`getChallenge()`
The challenge specifies the challenge that the authenticator signs, along with other data, when producing an attestation object for the newly created credential.
`List<PublicKeyCredentialDescriptor>`
`getExcludeCredentials()`
The excludeCredentials property is the OPTIONAL member used by the Relying Party to list any existing credentials mapped to this user account (as identified by user.id).
`AuthenticationExtensionsClientInputs`
`getExtensions()`
The extensions property is an OPTIONAL member used by the Relying Party to provide client extension inputs requesting additional processing by the client and authenticator.
`List<PublicKeyCredentialParameters>`
`getPubKeyCredParams()`
The publicKeyCredParams params lisst the key types and signature algorithms the Relying Party Supports, ordered from most preferred to least preferred.
`PublicKeyCredentialRpEntity`
`getRp()`
The rp property contains data about the Relying Party responsible for the request.
`Duration`
`getTimeout()`
The timeout property specifies a time, in milliseconds, that the Relying Party is willing to wait for the call to complete.
`PublicKeyCredentialUserEntity`
`getUser()`
The user contains names and an identifier for the user account performing the registration.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getRp

public PublicKeyCredentialRpEntity getRp()
The rp property contains data about the Relying Party responsible for the request.

Returns:
  the relying party

### getUser

public PublicKeyCredentialUserEntity getUser()
The user contains names and an identifier for the user account performing the registration.

Returns:
  the user

### getChallenge

public Bytes getChallenge()
The challenge specifies the challenge that the authenticator signs, along with other data, when producing an attestation object for the newly created credential.

Returns:
  the challenge

### getPubKeyCredParams

public List<PublicKeyCredentialParameters> getPubKeyCredParams()
The publicKeyCredParams params lisst the key types and signature algorithms the Relying Party Supports, ordered from most preferred to least preferred.

Returns:
  the public key credential parameters

### getTimeout

public Duration getTimeout()
The timeout property specifies a time, in milliseconds, that the Relying Party is willing to wait for the call to complete.

Returns:
  the timeout

### getExcludeCredentials

public List<PublicKeyCredentialDescriptor> getExcludeCredentials()
The excludeCredentials property is the OPTIONAL member used by the Relying Party to list any existing credentials mapped to this user account (as identified by user.id).

Returns:
  exclude credentials

### getAuthenticatorSelection

public AuthenticatorSelectionCriteria getAuthenticatorSelection()
The authenticatorSelection property is an OPTIONAL member used by the Relying Party to list any existing credentials mapped to this user account (as identified by user.id).

Returns:
  the authenticatorSelection

### getAttestation

public AttestationConveyancePreference getAttestation()
The attestation property is an OPTIONAL member used by the Relying Party to specify a preference regarding attestation conveyance.

Returns:
  the attestation preference

### getExtensions

public AuthenticationExtensionsClientInputs getExtensions()
The extensions property is an OPTIONAL member used by the Relying Party to provide client extension inputs requesting additional processing by the client and authenticator.

Returns:
  the extensions

### builder

public static PublicKeyCredentialCreationOptions.PublicKeyCredentialCreationOptionsBuilder builder()
Creates a new `PublicKeyCredentialCreationOptions`

Returns:
  a new `PublicKeyCredentialCreationOptions`